% To sparsify the columns of matrix P by zeroing the small elements

function [S_K,I_K]=K_sparsifying(P,K)
%=============================================
%    [Q_ini,R_ini]=Alg_LG_ini(....);      
%      K - sparsity = no. of no-zero elements:   1 <= K < J
%=============================================
  [J,L]=size(P);       
  
 S_K=P*0;  I_K=S_K; 
 
 for j=1:L
     v = P(:,j);  v_abs=abs(v); Z_p = zeros(J,1); 
     v_s = sort(-v_abs);  % descending order 
     val_K = -v_s(K);     %% the Kth largest value
     pos = find(v_abs(:)>= val_K);
     v_p = v*0;  v_p(pos) = v(pos);
     S_K(:,j) = v_p; 
     I_p = ones(J,1);  I_p(pos) = Z_p(pos);
     I_K(:,j) = I_p;   % I_K(i,j) =1 means S_K(i,j)=0
 end
     
 