imagepathCol =fullfile(pwd,'\eps_fig\');  % for color images
imagepathBW =fullfile(pwd,'\eps_fig_BW\');  % for BW images


figure
imshow(uint8(I),[0,255])
x0 =340; x1 = 400; y0 = 64; y1 = 150;
myzoom([0.628,0.58,0.4,0.35],[x0,x1,y0,y1])
print(gcf,'-depsc2',[imagepathCol,'barbaraZoom.eps'])
saveas(gcf,[imagepathCol,'barbara.fig']);


figure
imshow(uint8(In),[0,255])
myzoom([0.628,0.58,0.4,0.35],[x0,x1,y0,y1])
print(gcf,'-depsc2',[imagepathCol,'barbaraNoiseZoom.eps'])
saveas(gcf,[imagepathCol,'barbaraNoiseZoom.fig']);


figure
imshow(uint8(IdnAKSVD),[0,255])
myzoom([0.628,0.58,0.4,0.35],[x0,x1,y0,y1])
print(gcf,'-depsc2',[imagepathCol,'barbaraDeNoiseAKSVDZoom.eps'])
saveas(gcf,[imagepathCol,'barbaraDeNoiseAKSVDZoom.fig']);



figure
imshow(uint8(Idn),[0,255])
myzoom([0.628,0.58,0.4,0.35],[x0,x1,y0,y1])
print(gcf,'-depsc2',[imagepathCol,'barbaraDeNoiseLGZoom.eps'])
saveas(gcf,[imagepathCol,'barbaraDeNoiseLGZoom.fig']);